package at.ac.tuwien.dbai.alternation.examples;
/** Monotone Circuit Value Problem **/

public class MCVP {
	private at.ac.tuwien.dbai.alternation.runtime.ATM<Inputtape,Worktape> atm;

	public class Inputtape {
		Circuit circuit;
		boolean[] input;
		int outIndex;

		private Inputtape(Circuit circuit,boolean[] input,int outIndex) {
			super();
			this.circuit=circuit;
			this.input=input;
			this.outIndex=outIndex;
		}
	}

    public class Worktape implements at.ac.tuwien.dbai.alternation.runtime.InterfaceWorktape<Inputtape> {
    	public Circuit.Gate<Circuit.GateTypes> gate;

    	private Worktape(){
    		super();
    	}

    	private Worktape(Worktape worktape) {
    		this.gate = worktape.gate;
    	}

    	public void reset(Inputtape atmInputtape) {

    		this.gate=null;
    		this.gate = atmInputtape.circuit.getOutGate(atmInputtape.outIndex);
    	}

    	public Worktape clone(){
    		return new Worktape(this);
    	};

    	public boolean equals( Object o ) {
        	if ( o == null ) return false;
            if (! o.getClass().equals(getClass()) ) return false;
            Worktape tape2=(Worktape) o;
    		if(this.gate==null){
    			if(!(tape2.gate==null)) return false;
    		} else {
    		  	if(!this.gate.equals(tape2.gate)) return false;
    		}
            return true;
    	}

    	@Override
    	public int hashCode() {
    		final int prime = 31;
    		int result = 1;


    		result = prime * result + ((gate == null) ? 0 : gate.hashCode());

    		return result;
    	}

    	public String toString() {
    		StringBuffer ausgabe= new StringBuffer();

    		if (gate==null) {
    			ausgabe.append("gate=null; ");
    		} else {
    			ausgabe.append("gate=("+((Object)gate).toString()+"); ");
    		}

    		return ausgabe.toString();
    	}
    }

    private class evaluate extends at.ac.tuwien.dbai.alternation.runtime.State<Inputtape,Worktape>  {

    	public at.ac.tuwien.dbai.alternation.runtime.ResultTuple<Worktape> compute(Worktape atmWorktape) {
    		at.ac.tuwien.dbai.alternation.runtime.ResultTuple<Worktape> atmResultTuple;
    		Worktape atmWorktape2;
    		switch(atmWorktape.gate.type)
    				{
    					case INPUT:
    					if (atmInputtape.input[atmInputtape.circuit.getInputIndex(atmWorktape.gate)]==true){
    						return at.ac.tuwien.dbai.alternation.runtime.ResultTuple.ACCEPT;
    					} else {
    						return at.ac.tuwien.dbai.alternation.runtime.ResultTuple.REJECT;
    					}
    					case AND:
    					atmResultTuple = new at.ac.tuwien.dbai.alternation.runtime.ResultTuple<Worktape>(false, false, true);
    		atmWorktape2=atmWorktape.clone();
    		for(Circuit.Gate<Circuit.GateTypes> tempGate: atmWorktape.gate.getIn()){
    							{
    								atmWorktape.gate=tempGate;
    							}
    		atmResultTuple.add((byte)0,atmWorktape);
    		atmWorktape=atmWorktape2.clone();
    						}
    		return atmResultTuple;
    					case OR:
    					atmResultTuple = new at.ac.tuwien.dbai.alternation.runtime.ResultTuple<Worktape>(false, false, false);
    		atmWorktape2=atmWorktape.clone();
    		for(Circuit.Gate<Circuit.GateTypes> tempGate: atmWorktape.gate.getIn()){
    							{
    								atmWorktape.gate=tempGate;
    							}
    		atmResultTuple.add((byte)0,atmWorktape);
    		atmWorktape=atmWorktape2.clone();
    						}
    		return atmResultTuple;
    					case OUTPUT:
    					atmResultTuple = new at.ac.tuwien.dbai.alternation.runtime.ResultTuple<Worktape>(false, false, false);
    		atmWorktape2=atmWorktape.clone();
    		for(Circuit.Gate<Circuit.GateTypes> tempGate: atmWorktape.gate.getIn()){
    							{
    								atmWorktape.gate=tempGate;
    							}
    		atmResultTuple.add((byte)0,atmWorktape);
    		atmWorktape=atmWorktape2.clone();
    						}
    		return atmResultTuple;
    					default: return at.ac.tuwien.dbai.alternation.runtime.ResultTuple.REJECT;
    				}
    	}
    }

    public boolean compute(Circuit circuit,boolean[] input,int outIndex) {

    	Inputtape atmInput = new Inputtape(circuit,input,outIndex);
    	if (this.atm==null) {
    		Worktape atmWork = new  Worktape();
    		java.util.Map<Byte,at.ac.tuwien.dbai.alternation.runtime.State<Inputtape,Worktape>> atmStates = new java.util.HashMap<Byte,at.ac.tuwien.dbai.alternation.runtime.State<Inputtape,Worktape>>();

    		atmStates.put((byte)0,new evaluate());

    		this.atm = new at.ac.tuwien.dbai.alternation.runtime.ATMcyclic<Inputtape,Worktape>(atmStates, atmWork, (byte)0);
        }
        return atm.compute(atmInput);
    }

	public at.ac.tuwien.dbai.alternation.runtime.ComputationTree<Worktape> getComputationTree(){
		at.ac.tuwien.dbai.alternation.runtime.ComputationTree<Worktape> cT=this.atm.getComputationTree();
		cT.setName("MCVP");
		cT.setStateIdToName((byte)0, "evaluate");
		cT.setNameToStateId("evaluate",(byte) 0);

		return cT;
	}
}
