package at.ac.tuwien.dbai.alternation.runtime;
/**
 * simulation algorithm for alternating programs
 *
 * @author Wolfgang Dvorak
 *
 * @param <GInputtape> Container class for the input variables
 * @param <GWorktape> Container class for the work variables
 */
public interface ATM<GInputtape, GWorktape extends InterfaceWorktape<GInputtape>> {

	/**
	 *  simulates the machine on the given input
	 * @param input Container with the input
	 * @return true if accepts and false if rejects
	 */
	public abstract boolean compute(GInputtape input);

	/**
	 *
	 * @return computation tree if available otherwise null
	 */
	public abstract ComputationTree<GWorktape> getComputationTree();

}