package at.ac.tuwien.dbai.alternation.runtime;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class ComputationTreeCyclic<GWorktape extends InterfaceWorktape> extends ComputationTree<GWorktape> {
	private Map<ComputationNode<GWorktape>,List<ComputationNode<GWorktape>>> nullEdges= new HashMap<ComputationNode<GWorktape>,List<ComputationNode<GWorktape>>>();


	public boolean addNullEdge(ComputationNode<GWorktape> parent, ComputationNode<GWorktape> child){
		ComputationNode<GWorktape> localParent=parent;
		ComputationNode<GWorktape> localChild=child;
		if(nodes.containsKey(parent)){
			localParent=nodes.get(parent);
		}

		if(nodes.containsKey(child)){
			localChild=nodes.get(child);
		}

		if (!nullEdges.containsKey(localChild)){
			nullEdges.put(localChild, new ArrayList<ComputationNode<GWorktape>>());
		}
		return nullEdges.get(localChild).add(localParent);
	}

	public void removeNullEdges(ComputationNode<GWorktape> child){
		nullEdges.remove(child);
	}

	public List<ComputationNode<GWorktape>> getParents(ComputationNode<GWorktape> child){
		return nullEdges.get(child);
	}

}
